kernel.mk: Refactor LINUX_KARCH affectation
[openwrt/staging/wigyori.git] / include / kernel.mk
1 #
2 # Copyright (C) 2006-2011 OpenWrt.org
3 #
4 # This is free software, licensed under the GNU General Public License v2.
5 # See /LICENSE for more information.
6 #
7
8 ifeq ($(__target_inc),)
9 include $(INCLUDE_DIR)/target.mk
10 endif
11
12 ifeq ($(DUMP),1)
13 KERNEL?=<KERNEL>
14 BOARD?=<BOARD>
15 LINUX_VERSION?=<LINUX_VERSION>
16 LINUX_VERMAGIC?=<LINUX_VERMAGIC>
17 else
18 ifeq ($(CONFIG_EXTERNAL_TOOLCHAIN),)
19 export GCC_HONOUR_COPTS=s
20 endif
21
22 LINUX_KMOD_SUFFIX=ko
23
24 ifneq (,$(findstring uml,$(BOARD)))
25 KERNEL_CC?=$(HOSTCC)
26 KERNEL_CROSS?=
27 else
28 KERNEL_CC?=$(TARGET_CC)
29 KERNEL_CROSS?=$(TARGET_CROSS)
30 endif
31
32 ifeq ($(TARGET_BUILD),1)
33 PATCH_DIR ?= ./patches$(if $(wildcard ./patches-$(KERNEL_PATCHVER)),-$(KERNEL_PATCHVER))
34 FILES_DIR ?= $(foreach dir,$(wildcard ./files ./files-$(KERNEL_PATCHVER)),"$(dir)")
35 endif
36 KERNEL_BUILD_DIR ?= $(BUILD_DIR)/linux-$(BOARD)$(if $(SUBTARGET),_$(SUBTARGET))
37 LINUX_DIR ?= $(KERNEL_BUILD_DIR)/linux-$(LINUX_VERSION)
38 ifeq ($(strip $(call CompareKernelPatchVer,$(KERNEL_PATCHVER),ge,3.7.0)),1)
39 LINUX_UAPI_DIR=uapi/
40 endif
41 LINUX_VERMAGIC:=$(strip $(shell cat $(LINUX_DIR)/.vermagic 2>/dev/null))
42 LINUX_VERMAGIC:=$(if $(LINUX_VERMAGIC),$(LINUX_VERMAGIC),unknown)
43
44 LINUX_UNAME_VERSION:=$(if $(word 3,$(subst ., ,$(KERNEL_BASE))),$(KERNEL_BASE),$(KERNEL_BASE).0)
45 ifneq ($(findstring -rc,$(LINUX_VERSION)),)
46 LINUX_UNAME_VERSION:=$(LINUX_UNAME_VERSION)-$(strip $(lastword $(subst -, ,$(LINUX_VERSION))))
47 endif
48
49 MODULES_SUBDIR:=lib/modules/$(LINUX_UNAME_VERSION)
50 TARGET_MODULES_DIR := $(LINUX_TARGET_DIR)/$(MODULES_SUBDIR)
51
52 LINUX_KERNEL:=$(KERNEL_BUILD_DIR)/vmlinux
53
54 LINUX_SOURCE:=linux-$(LINUX_VERSION).tar.xz
55 TESTING:=$(if $(findstring -rc,$(LINUX_VERSION)),/testing,)
56 ifeq ($(call qstrip,$(CONFIG_EXTERNAL_KERNEL_TREE))$(call qstrip,$(CONFIG_KERNEL_GIT_CLONE_URI)),)
57 LINUX_SITE:=@KERNEL/linux/kernel/v3.x$(TESTING)
58 endif
59
60 ifneq ($(TARGET_BUILD),1)
61 PKG_BUILD_DIR ?= $(KERNEL_BUILD_DIR)/$(PKG_NAME)$(if $(PKG_VERSION),-$(PKG_VERSION))
62 endif
63 endif
64
65 ifneq (,$(findstring uml,$(BOARD)))
66 LINUX_KARCH=um
67 else ifneq (,$(findstring $(ARCH), aarch64 aarch64_be))
68 LINUX_KARCH := arm64
69 else ifneq (,$(findstring $(ARCH), armeb))
70 LINUX_KARCH := arm
71 else ifneq (,$(findstring $(ARCH), mipsel mips64 mips64el))
72 LINUX_KARCH := mips
73 else ifneq (,$(findstring $(ARCH), sh2 sh3 sh4))
74 LINUX_KARCH := sh
75 else ifneq (,$(findstring $(ARCH), i386))
76 LINUX_KARCH := x86
77 else
78 LINUX_KARCH := $(ARCH)
79 endif
80
81 define KernelPackage/Defaults
82 FILES:=
83 AUTOLOAD:=
84 endef
85
86 define ModuleAutoLoad
87 $(SH_FUNC) \
88 export modules=; \
89 probe_module() { \
90 mods="$$$$$$$$1"; \
91 boot="$$$$$$$$2"; \
92 shift 2; \
93 for mod in $$$$$$$$mods; do \
94 mkdir -p $(2)/etc/modules.d; \
95 echo "$$$$$$$$mod" >> $(2)/etc/modules.d/$(1); \
96 done; \
97 if [ -e $(2)/etc/modules.d/$(1) ]; then \
98 if [ "$$$$$$$$boot" = "1" ]; then \
99 mkdir -p $(2)/etc/modules-boot.d; \
100 ln -s ../modules.d/$(1) $(2)/etc/modules-boot.d/; \
101 fi; \
102 modules="$$$$$$$${modules:+$$$$$$$$modules}"; \
103 fi; \
104 }; \
105 add_module() { \
106 priority="$$$$$$$$1"; \
107 mods="$$$$$$$$2"; \
108 boot="$$$$$$$$3"; \
109 shift 3; \
110 for mod in $$$$$$$$mods; do \
111 mkdir -p $(2)/etc/modules.d; \
112 echo "$$$$$$$$mod" >> $(2)/etc/modules.d/$$$$$$$$priority-$(1); \
113 done; \
114 if [ -e $(2)/etc/modules.d/$$$$$$$$priority-$(1) ]; then \
115 if [ "$$$$$$$$boot" = "1" ]; then \
116 mkdir -p $(2)/etc/modules-boot.d; \
117 ln -s ../modules.d/$$$$$$$$priority-$(1) $(2)/etc/modules-boot.d/; \
118 fi; \
119 modules="$$$$$$$${modules:+$$$$$$$$modules }$$$$$$$$priority-$(1)"; \
120 fi; \
121 }; \
122 $(3) \
123 if [ -n "$$$$$$$$modules" ]; then \
124 mkdir -p $(2)/etc/modules.d; \
125 mkdir -p $(2)/CONTROL; \
126 echo "#!/bin/sh" > $(2)/CONTROL/postinst; \
127 echo "[ -z \"\$$$$$$$$IPKG_INSTROOT\" ] || exit 0" >> $(2)/CONTROL/postinst; \
128 echo ". /lib/functions.sh" >> $(2)/CONTROL/postinst; \
129 echo "insert_modules $$$$$$$$modules" >> $(2)/CONTROL/postinst; \
130 chmod 0755 $(2)/CONTROL/postinst; \
131 fi
132 endef
133
134 ifeq ($(DUMP)$(TARGET_BUILD),)
135 -include $(LINUX_DIR)/.config
136 endif
137
138 define KernelPackage/depends
139 $(STAMP_BUILT): $(LINUX_DIR)/.config
140 define KernelPackage/depends
141 endef
142 endef
143
144 define KernelPackage
145 NAME:=$(1)
146 $(eval $(call Package/Default))
147 $(eval $(call KernelPackage/Defaults))
148 $(eval $(call KernelPackage/$(1)))
149 $(eval $(call KernelPackage/$(1)/$(BOARD)))
150
151 define Package/kmod-$(1)
152 TITLE:=$(TITLE)
153 SECTION:=kernel
154 CATEGORY:=Kernel modules
155 DESCRIPTION:=$(DESCRIPTION)
156 EXTRA_DEPENDS:=kernel (=$(LINUX_VERSION)-$(LINUX_RELEASE)-$(LINUX_VERMAGIC))
157 VERSION:=$(LINUX_VERSION)$(if $(PKG_VERSION),+$(PKG_VERSION))-$(if $(PKG_RELEASE),$(PKG_RELEASE),$(LINUX_RELEASE))
158 $(call KernelPackage/$(1))
159 $(call KernelPackage/$(1)/$(BOARD))
160 endef
161
162 ifdef KernelPackage/$(1)/description
163 define Package/kmod-$(1)/description
164 $(call KernelPackage/$(1)/description)
165 endef
166 endif
167
168 ifdef KernelPackage/$(1)/config
169 define Package/kmod-$(1)/config
170 $(call KernelPackage/$(1)/config)
171 endef
172 endif
173
174 $(call KernelPackage/depends)
175
176 ifneq ($(if $(filter-out %=y %=n %=m,$(KCONFIG)),$(filter m y,$(foreach c,$(filter-out %=y %=n %=m,$(KCONFIG)),$($(c)))),.),)
177 ifneq ($(if $(SDK),$(filter-out $(LINUX_DIR)/%.ko,$(FILES)),$(strip $(FILES))),)
178 define Package/kmod-$(1)/install
179 @for mod in $$(FILES); do \
180 if [ -e $$$$$$$$mod ]; then \
181 mkdir -p $$(1)/$(MODULES_SUBDIR) ; \
182 $(CP) -L $$$$$$$$mod $$(1)/$(MODULES_SUBDIR)/ ; \
183 elif [ -e "$(LINUX_DIR)/modules.builtin" ]; then \
184 if grep -q "$$$$$$$${mod##$(LINUX_DIR)/}" "$(LINUX_DIR)/modules.builtin"; then \
185 echo "NOTICE: module '$$$$$$$$mod' is built-in."; \
186 else \
187 echo "ERROR: module '$$$$$$$$mod' is missing." >&2; \
188 exit 1; \
189 fi; \
190 else \
191 echo "WARNING: module '$$$$$$$$mod' missing and modules.builtin not available, assuming built-in." >&2; \
192 fi; \
193 done;
194 $(call ModuleAutoLoad,$(1),$$(1),$(AUTOLOAD))
195 $(call KernelPackage/$(1)/install,$$(1))
196 endef
197 endif
198 $(if $(CONFIG_PACKAGE_kmod-$(1)),
199 else
200 compile: $(1)-disabled
201 $(1)-disabled:
202 @echo "WARNING: kmod-$(1) is not available in the kernel config - generating empty package" >&2
203
204 define Package/kmod-$(1)/install
205 true
206 endef
207 )
208 endif
209 $$(eval $$(call BuildPackage,kmod-$(1)))
210
211 $$(IPKG_kmod-$(1)): $$(wildcard $$(FILES))
212 endef
213
214 define AutoLoad
215 add_module "$(1)" "$(2)" "$(3)";
216 endef
217
218 define AutoProbe
219 probe_module "$(1)" "$(2)";
220 endef
221
222 version_field=$(if $(word $(1),$(2)),$(word $(1),$(2)),0)
223 kernel_version_merge=$$(( ($(call version_field,1,$(1)) << 24) + ($(call version_field,2,$(1)) << 16) + ($(call version_field,3,$(1)) << 8) + $(call version_field,4,$(1)) ))
224
225 ifdef DUMP
226 kernel_version_cmp=
227 else
228 kernel_version_cmp=$(shell [ $(call kernel_version_merge,$(call split_version,$(2))) $(1) $(call kernel_version_merge,$(call split_version,$(3))) ] && echo 1 )
229 endif
230
231 CompareKernelPatchVer=$(if $(call kernel_version_cmp,-$(2),$(1),$(3)),1,0)
232
233 kernel_patchver_gt=$(call kernel_version_cmp,-gt,$(KERNEL_PATCHVER),$(1))
234 kernel_patchver_ge=$(call kernel_version_cmp,-ge,$(KERNEL_PATCHVER),$(1))
235 kernel_patchver_eq=$(call kernel_version_cmp,-eq,$(KERNEL_PATCHVER),$(1))
236 kernel_patchver_le=$(call kernel_version_cmp,-le,$(KERNEL_PATCHVER),$(1))
237 kernel_patchver_lt=$(call kernel_version_cmp,-lt,$(KERNEL_PATCHVER),$(1))
238